package lab;

import lab.storage.DbConnector;
import lab.storage.ScoreStorageInterface;
import lombok.AllArgsConstructor;
import lombok.Builder.Default;
import lombok.Getter;

@Getter
@AllArgsConstructor
@lombok.Builder(toBuilder = true)
public class Config {

	@Getter
	private static Config instance;

	@Default
	private ScoreStorageInterface scoreStorageInterface = new DbConnector();
	@Default
	private double monsterMinXPopsition = 0.5;
	@Default
	private double monsterMinSpeed = 50;
	@Default
	private double monsterMaxSpeed = 150;
	@Default
	private double obstacleWidth = 30;
	@Default
	private double obstacleHeight = 20;
	@Default
	private double playerStartSpeed = 50;
	@Default
	private int monsterMultiplier = 1;

	public static void configure(Config setting) {
		instance = setting;
	}

	public static Config getInstanceForHardcoreGame() {
		return builder().monsterMinSpeed(150).monsterMaxSpeed(500).monsterMultiplier(5).monsterMinXPopsition(0.2)
				.build();
	}

}
